# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.Credential import Credential  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.Dns import Dns  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class ADDnsFailover(ExternalizableAbstractModel):
    """ADDnsFailover - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'primary_ad_credential': 'files.v4.config.Credential',
        'primary_dns': 'files.v4.config.Dns',
        'primary_ad_preferred_domain_controller': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'primary_ad_credential': 'primaryAdCredential',
        'primary_dns': 'primaryDns',
        'primary_ad_preferred_domain_controller': 'primaryAdPreferredDomainController',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, primary_ad_credential=None, primary_dns=None, primary_ad_preferred_domain_controller=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """ADDnsFailover - a model defined in Swagger
            \nActive directory DNS failover
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__primary_ad_credential = None
        self.__primary_dns = None
        self.__primary_ad_preferred_domain_controller = None
        self.discriminator = None
        if primary_ad_credential is not None:
            self.__primary_ad_credential = primary_ad_credential
        if primary_dns is not None:
            self.__primary_dns = primary_dns
        if primary_ad_preferred_domain_controller is not None:
            self.__primary_ad_preferred_domain_controller = primary_ad_preferred_domain_controller

    def _initialize_object_type(self):
        return 'files.v4.config.ADDnsFailover'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.ADDnsFailover'


    @property
    def primary_ad_credential(self):
        """`{ files.v4.config.Credential }`
            
        """ # noqa: E501
        return self.__primary_ad_credential

    @primary_ad_credential.setter
    def primary_ad_credential(self, primary_ad_credential):

        self.__primary_ad_credential = primary_ad_credential

    @property
    def primary_dns(self):
        """`{ files.v4.config.Dns }`
            
        """ # noqa: E501
        return self.__primary_dns

    @primary_dns.setter
    def primary_dns(self, primary_dns):

        self.__primary_dns = primary_dns

    @property
    def primary_ad_preferred_domain_controller(self):
        """`{ str }`
            \nUse a specific domain controller for the join-domain operation in a multi DC active directory setup. By default, AFS discovers a site local domain controller for join-domain operation. The preferred domain controller cannot be an IP address. It has to be FQDN (example: dc_name.dom.companyname.com)
        """ # noqa: E501
        return self.__primary_ad_preferred_domain_controller

    @primary_ad_preferred_domain_controller.setter
    def primary_ad_preferred_domain_controller(self, primary_ad_preferred_domain_controller):

        self.__primary_ad_preferred_domain_controller = primary_ad_preferred_domain_controller

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ADDnsFailover, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ADDnsFailover):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

