# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.ClientBlockingFilter import ClientBlockingFilter  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class BlockedClients(object):
    """BlockedClients - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'ro_access_filters': 'list[files.v4.config.ClientBlockingFilter]',
        'no_access_filters': 'list[files.v4.config.ClientBlockingFilter]',
        'rw_access_filters': 'list[files.v4.config.ClientBlockingFilter]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ro_access_filters': 'roAccessFilters',
        'no_access_filters': 'noAccessFilters',
        'rw_access_filters': 'rwAccessFilters',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ro_access_filters=None, no_access_filters=None, rw_access_filters=None, *args, **kwargs):  # noqa: E501
        """BlockedClients - a model defined in Swagger
            \nBlocked clients due to read-only or no access.
        """
        self.__ro_access_filters = None
        self.__no_access_filters = None
        self.__rw_access_filters = None
        self.discriminator = None
        if ro_access_filters is not None:
            self.__ro_access_filters = ro_access_filters
        if no_access_filters is not None:
            self.__no_access_filters = no_access_filters
        if rw_access_filters is not None:
            self.__rw_access_filters = rw_access_filters
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.BlockedClients'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.BlockedClients'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ro_access_filters(self):
        """`{ list[files.v4.config.ClientBlockingFilter] }`
            \nRead only access clients
        """ # noqa: E501
        return self.__ro_access_filters

    @ro_access_filters.setter
    def ro_access_filters(self, ro_access_filters):

        self.__ro_access_filters = ro_access_filters

    @property
    def no_access_filters(self):
        """`{ list[files.v4.config.ClientBlockingFilter] }`
            \nNo access clients
        """ # noqa: E501
        return self.__no_access_filters

    @no_access_filters.setter
    def no_access_filters(self, no_access_filters):

        self.__no_access_filters = no_access_filters

    @property
    def rw_access_filters(self):
        """`{ list[files.v4.config.ClientBlockingFilter] }`
            \nRead write access clients
        """ # noqa: E501
        return self.__rw_access_filters

    @rw_access_filters.setter
    def rw_access_filters(self, rw_access_filters):

        self.__rw_access_filters = rw_access_filters

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BlockedClients, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BlockedClients):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

