# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class ClientBlockingFilter(object):
    """ClientBlockingFilter - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'vendor_name': 'str',
        'ip_list': 'list[common.v1.config.IPAddress]',
        'sid_list': 'list[str]',
        'uid_list': 'list[int]',
        'gid_list': 'list[int]',
        'block_all_ips': 'bool',
        'is_block_all_ips': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vendor_name': 'vendorName',
        'ip_list': 'ipList',
        'sid_list': 'sidList',
        'uid_list': 'uidList',
        'gid_list': 'gidList',
        'block_all_ips': 'blockAllIps',
        'is_block_all_ips': 'isBlockAllIps',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vendor_name=None, ip_list=None, sid_list=None, uid_list=None, gid_list=None, block_all_ips=False, is_block_all_ips=False, *args, **kwargs):  # noqa: E501
        """ClientBlockingFilter - a model defined in Swagger
            \nBlocked clients filter
        """
        self.__vendor_name = None
        self.__ip_list = None
        self.__sid_list = None
        self.__uid_list = None
        self.__gid_list = None
        self.__block_all_ips = None
        self.__is_block_all_ips = None
        self.discriminator = None
        if vendor_name is not None:
            self.__vendor_name = vendor_name
        if ip_list is not None:
            self.__ip_list = ip_list
        if sid_list is not None:
            self.__sid_list = sid_list
        if uid_list is not None:
            self.__uid_list = uid_list
        if gid_list is not None:
            self.__gid_list = gid_list
        if block_all_ips is not None:
            self.__block_all_ips = block_all_ips
        if is_block_all_ips is not None:
            self.__is_block_all_ips = is_block_all_ips
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.ClientBlockingFilter'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.ClientBlockingFilter'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def vendor_name(self):
        """`{ str }`
            \nVendor name
        """ # noqa: E501
        return self.__vendor_name

    @vendor_name.setter
    def vendor_name(self, vendor_name):

        self.__vendor_name = vendor_name

    @property
    def ip_list(self):
        """`{ list[common.v1.config.IPAddress] }`
            \nIP address list
        """ # noqa: E501
        return self.__ip_list

    @ip_list.setter
    def ip_list(self, ip_list):

        self.__ip_list = ip_list

    @property
    def sid_list(self):
        """`{ list[str] }`
            \nSID list
        """ # noqa: E501
        return self.__sid_list

    @sid_list.setter
    def sid_list(self, sid_list):

        self.__sid_list = sid_list

    @property
    def uid_list(self):
        """`{ list[int] }`
            \nUID list
        """ # noqa: E501
        return self.__uid_list

    @uid_list.setter
    def uid_list(self, uid_list):

        self.__uid_list = uid_list

    @property
    def gid_list(self):
        """`{ list[int] }`
            \nGID list
        """ # noqa: E501
        return self.__gid_list

    @gid_list.setter
    def gid_list(self, gid_list):

        self.__gid_list = gid_list

    @property
    def block_all_ips(self):
        """`{ bool }`
            \nBlock all IP addresses. This field will be deprecated.
        """ # noqa: E501
        return self.__block_all_ips

    @block_all_ips.setter
    def block_all_ips(self, block_all_ips):

        self.__block_all_ips = block_all_ips

    @property
    def is_block_all_ips(self):
        """`{ bool }`
            \nBlock all IP addresses
        """ # noqa: E501
        return self.__is_block_all_ips

    @is_block_all_ips.setter
    def is_block_all_ips(self, is_block_all_ips):

        self.__is_block_all_ips = is_block_all_ips

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClientBlockingFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClientBlockingFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

