# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.DataProtectionPolicyType import DataProtectionPolicyType  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.PolicyStatus import PolicyStatus  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.ReplicationSummary import ReplicationSummary  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.SubPolicy import SubPolicy  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class DataProtectionPolicy(ExternalizableAbstractModel):
    """DataProtectionPolicy - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'sub_policies': 'list[files.v4.config.SubPolicy]',
        'policy_status': 'files.v4.config.PolicyStatus',
        'replication_summary': 'files.v4.config.ReplicationSummary',
        'type': 'files.v4.config.DataProtectionPolicyType',
        'is_reverse_policy': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'sub_policies': 'subPolicies',
        'policy_status': 'policyStatus',
        'replication_summary': 'replicationSummary',
        'type': 'type',
        'is_reverse_policy': 'isReversePolicy',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, sub_policies=None, policy_status=None, replication_summary=None, type=None, is_reverse_policy=False, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """DataProtectionPolicy - a model defined in Swagger
            \nData protection policy
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__sub_policies = None
        self.__policy_status = None
        self.__replication_summary = None
        self.__type = None
        self.__is_reverse_policy = None
        self.discriminator = None
        self.__name = name
        if description is not None:
            self.__description = description
        if sub_policies is not None:
            self.__sub_policies = sub_policies
        if policy_status is not None:
            self.__policy_status = policy_status
        if replication_summary is not None:
            self.__replication_summary = replication_summary
        self.__type = type
        if is_reverse_policy is not None:
            self.__is_reverse_policy = is_reverse_policy

    def _initialize_object_type(self):
        return 'files.v4.config.DataProtectionPolicy'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.DataProtectionPolicy'


    @property
    def name(self):
        """`{ str }`
            \nName of the policy
        """ # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 30:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `30`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """`{ str }`
            \nPolicy description
        """ # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 180:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `180`")  # noqa: E501

        self.__description = description

    @property
    def sub_policies(self):
        """`{ list[files.v4.config.SubPolicy] }`
            \nData location represents combination of source, target, source target map, schedules, policy status and replication summary status.
        """ # noqa: E501
        return self.__sub_policies

    @sub_policies.setter
    def sub_policies(self, sub_policies):

        self.__sub_policies = sub_policies

    @property
    def policy_status(self):
        """`{ files.v4.config.PolicyStatus }`
            
        """ # noqa: E501
        return self.__policy_status

    @policy_status.setter
    def policy_status(self, policy_status):

        self.__policy_status = policy_status

    @property
    def replication_summary(self):
        """`{ files.v4.config.ReplicationSummary }`
            
        """ # noqa: E501
        return self.__replication_summary

    @replication_summary.setter
    def replication_summary(self, replication_summary):

        self.__replication_summary = replication_summary

    @property
    def type(self):
        """`{ files.v4.config.DataProtectionPolicyType }`
            
        """ # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self.__type = type

    @property
    def is_reverse_policy(self):
        """`{ bool }`
            \nThis flag indicates if this policy has been used for reverse replication.
        """ # noqa: E501
        return self.__is_reverse_policy

    @is_reverse_policy.setter
    def is_reverse_policy(self, is_reverse_policy):

        self.__is_reverse_policy = is_reverse_policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DataProtectionPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataProtectionPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

