# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class DeactivateSpec(ExternalizableAbstractModel):
    """DeactivateSpec - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'replicate_final_delta': 'bool',
        'primary_file_server_ext_id': 'str',
        'target_file_server_ext_id': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'replicate_final_delta': 'replicateFinalDelta',
        'primary_file_server_ext_id': 'primaryFileServerExtId',
        'target_file_server_ext_id': 'targetFileServerExtId',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, replicate_final_delta=False, primary_file_server_ext_id=None, target_file_server_ext_id=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """DeactivateSpec - a model defined in Swagger
            \nDeActivation involves, making the mount targets for the provided file server pair read-only and replicating the final delta, if needed.
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__replicate_final_delta = None
        self.__primary_file_server_ext_id = None
        self.__target_file_server_ext_id = None
        self.discriminator = None
        if replicate_final_delta is not None:
            self.__replicate_final_delta = replicate_final_delta
        if primary_file_server_ext_id is not None:
            self.__primary_file_server_ext_id = primary_file_server_ext_id
        if target_file_server_ext_id is not None:
            self.__target_file_server_ext_id = target_file_server_ext_id

    def _initialize_object_type(self):
        return 'files.v4.config.DeactivateSpec'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.DeactivateSpec'


    @property
    def replicate_final_delta(self):
        """`{ bool }`
            \nFlag to indicate whether the final delta needs to be replicated or not.
        """ # noqa: E501
        return self.__replicate_final_delta

    @replicate_final_delta.setter
    def replicate_final_delta(self, replicate_final_delta):

        self.__replicate_final_delta = replicate_final_delta

    @property
    def primary_file_server_ext_id(self):
        """`{ str }`
            \nThe {extId} of the primary file server. This is a read-only field.
        """ # noqa: E501
        return self.__primary_file_server_ext_id

    @primary_file_server_ext_id.setter
    def primary_file_server_ext_id(self, primary_file_server_ext_id):
        if primary_file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', primary_file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `primary_file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__primary_file_server_ext_id = primary_file_server_ext_id

    @property
    def target_file_server_ext_id(self):
        """`{ str }`
            \nThe {extId} of the target file server. This is a read-only field.
        """ # noqa: E501
        return self.__target_file_server_ext_id

    @target_file_server_ext_id.setter
    def target_file_server_ext_id(self, target_file_server_ext_id):
        if target_file_server_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', target_file_server_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `target_file_server_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__target_file_server_ext_id = target_file_server_ext_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeactivateSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeactivateSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

