# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class DnsDetails(ExternalizableAbstractModel):
    """DnsDetails - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'ip_address': 'str',
        'host_name': 'str',
        'is_verified': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ip_address': 'ipAddress',
        'host_name': 'hostName',
        'is_verified': 'isVerified',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ip_address=None, host_name=None, is_verified=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """DnsDetails - a model defined in Swagger
            \nDNS detail for the file server.
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__ip_address = None
        self.__host_name = None
        self.__is_verified = None
        self.discriminator = None
        if ip_address is not None:
            self.__ip_address = ip_address
        if host_name is not None:
            self.__host_name = host_name
        if is_verified is not None:
            self.__is_verified = is_verified

    def _initialize_object_type(self):
        return 'files.v4.config.DnsDetails'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.DnsDetails'


    @property
    def ip_address(self):
        """`{ str }`
            \nIPV4 address of the DNS server. This is a read-only field.
        """ # noqa: E501
        return self.__ip_address

    @ip_address.setter
    def ip_address(self, ip_address):

        self.__ip_address = ip_address

    @property
    def host_name(self):
        """`{ str }`
            \nHost name for the DNS server. This is a read-only field.
        """ # noqa: E501
        return self.__host_name

    @host_name.setter
    def host_name(self, host_name):

        self.__host_name = host_name

    @property
    def is_verified(self):
        """`{ bool }`
            \nThis field indicates if the DNS server is verified. This is a read-only field.
        """ # noqa: E501
        return self.__is_verified

    @is_verified.setter
    def is_verified(self, is_verified):

        self.__is_verified = is_verified

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DnsDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DnsDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

