# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.ActionStatus import ActionStatus  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.DataProtectionPolicy import DataProtectionPolicy  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.FailOverType import FailOverType  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.FileServerState import FileServerState  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.ProtectedFileServerPair import ProtectedFileServerPair  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class FailoverSpec(ProtectedFileServerPair):
    """FailoverSpec - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'reverse_replication_policy': 'files.v4.config.DataProtectionPolicy',
        'type': 'files.v4.config.FailOverType',
        'owning_file_server_ext_id': 'str',
        'policy_ext_ids': 'list[str]',
        'file_server_state': 'files.v4.config.FileServerState',
        'status': 'files.v4.config.ActionStatus',
        'primary_file_server_ext_id': 'str',
        'target_file_server_ext_id': 'str',
        'primary_ad_credential': 'files.v4.config.Credential',
        'primary_dns': 'files.v4.config.Dns',
        'primary_ad_preferred_domain_controller': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'reverse_replication_policy': 'reverseReplicationPolicy',
        'type': 'type',
        'owning_file_server_ext_id': 'owningFileServerExtId',
        'policy_ext_ids': 'policyExtIds',
        'file_server_state': 'fileServerState',
        'status': 'status',
        'primary_file_server_ext_id': 'primaryFileServerExtId',
        'target_file_server_ext_id': 'targetFileServerExtId',
        'primary_ad_credential': 'primaryAdCredential',
        'primary_dns': 'primaryDns',
        'primary_ad_preferred_domain_controller': 'primaryAdPreferredDomainController',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, reverse_replication_policy=None, type=None, owning_file_server_ext_id=None, policy_ext_ids=None, file_server_state=None, status=None, primary_file_server_ext_id=None, target_file_server_ext_id=None, primary_ad_credential=None, primary_dns=None, primary_ad_preferred_domain_controller=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """FailoverSpec - a model defined in Swagger
            \nFailover model.
        """
        ProtectedFileServerPair.__init__(self, owning_file_server_ext_id, policy_ext_ids, file_server_state, status, primary_file_server_ext_id, target_file_server_ext_id, primary_ad_credential, primary_dns, primary_ad_preferred_domain_controller, ext_id, links, tenant_id, *args, **kwargs)
        self.__reverse_replication_policy = None
        self.__type = None
        self.discriminator = None
        if reverse_replication_policy is not None:
            self.__reverse_replication_policy = reverse_replication_policy
        if type is not None:
            self.__type = type

    def _initialize_object_type(self):
        return 'files.v4.config.FailoverSpec'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.FailoverSpec'


    @property
    def reverse_replication_policy(self):
        """`{ files.v4.config.DataProtectionPolicy }`
            
        """ # noqa: E501
        return self.__reverse_replication_policy

    @reverse_replication_policy.setter
    def reverse_replication_policy(self, reverse_replication_policy):

        self.__reverse_replication_policy = reverse_replication_policy

    @property
    def type(self):
        """`{ files.v4.config.FailOverType }`
            
        """ # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FailoverSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FailoverSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

