# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class MigrationPair(ExternalizableAbstractModel):
    """MigrationPair - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'source_path': 'str',
        'target_path': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'source_path': 'sourcePath',
        'target_path': 'targetPath',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, source_path=None, target_path=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """MigrationPair - a model defined in Swagger
            \nMigration pair details
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__source_path = None
        self.__target_path = None
        self.discriminator = None
        self.__source_path = source_path
        if target_path is not None:
            self.__target_path = target_path

    def _initialize_object_type(self):
        return 'files.v4.config.MigrationPair'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.MigrationPair'


    @property
    def source_path(self):
        """`{ str }`
            \nAbsolute source path.  For the source paths ending with '/', the contents will be copied directly into the target folder.\\n For the paths, ending with name, a new folder with the same name will be created on the target server and then the data is synced.\" 
        """ # noqa: E501
        return self.__source_path

    @source_path.setter
    def source_path(self, source_path):
        if source_path is None:
            raise ValueError("Invalid value for `source_path`, must not be `None`")  # noqa: E501

        self.__source_path = source_path

    @property
    def target_path(self):
        """`{ str }`
            \nAbsolute path for the target. For example: '/share1/dir1'. Path should always start with a root folder.
        """ # noqa: E501
        return self.__target_path

    @target_path.setter
    def target_path(self, target_path):

        self.__target_path = target_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MigrationPair, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationPair):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

