# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.MigrationSubPlan import MigrationSubPlan  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class MigrationPlan(ExternalizableAbstractModel):
    """MigrationPlan - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'name': 'str',
        'source_ext_id': 'str',
        'sub_plans': 'list[files.v4.config.MigrationSubPlan]',
        'description': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'source_ext_id': 'sourceExtId',
        'sub_plans': 'subPlans',
        'description': 'description',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, source_ext_id=None, sub_plans=None, description=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """MigrationPlan - a model defined in Swagger
            \nMigration plan details
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__source_ext_id = None
        self.__sub_plans = None
        self.__description = None
        self.discriminator = None
        self.__name = name
        self.__source_ext_id = source_ext_id
        self.__sub_plans = sub_plans
        if description is not None:
            self.__description = description

    def _initialize_object_type(self):
        return 'files.v4.config.MigrationPlan'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.MigrationPlan'


    @property
    def name(self):
        """`{ str }`
            \nMigration plan name
        """ # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self.__name = name

    @property
    def source_ext_id(self):
        """`{ str }`
            \nSource ExtId for the migration plan
        """ # noqa: E501
        return self.__source_ext_id

    @source_ext_id.setter
    def source_ext_id(self, source_ext_id):
        if source_ext_id is None:
            raise ValueError("Invalid value for `source_ext_id`, must not be `None`")  # noqa: E501
        if source_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', source_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `source_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__source_ext_id = source_ext_id

    @property
    def sub_plans(self):
        """`{ list[files.v4.config.MigrationSubPlan] }`
            
        """ # noqa: E501
        return self.__sub_plans

    @sub_plans.setter
    def sub_plans(self, sub_plans):
        if sub_plans is None:
            raise ValueError("Invalid value for `sub_plans`, must not be `None`")  # noqa: E501

        self.__sub_plans = sub_plans

    @property
    def description(self):
        """`{ str }`
            \nDescription of migration plan
        """ # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):

        self.__description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MigrationPlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationPlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

