# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class MultiProtocol(object):
    """MultiProtocol - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'enable_concurrent_reads': 'bool',
        'is_enable_concurrent_reads': 'bool',
        'enable_casesensitive_namespace': 'bool',
        'is_enable_casesensitive_namespace': 'bool',
        'enable_symlink_creation': 'bool',
        'is_enable_symlink_creation': 'bool',
        'enable_simulteneous_access': 'bool',
        'is_enable_simulteneous_access': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'enable_concurrent_reads': 'enableConcurrentReads',
        'is_enable_concurrent_reads': 'isEnableConcurrentReads',
        'enable_casesensitive_namespace': 'enableCasesensitiveNamespace',
        'is_enable_casesensitive_namespace': 'isEnableCasesensitiveNamespace',
        'enable_symlink_creation': 'enableSymlinkCreation',
        'is_enable_symlink_creation': 'isEnableSymlinkCreation',
        'enable_simulteneous_access': 'enableSimulteneousAccess',
        'is_enable_simulteneous_access': 'isEnableSimulteneousAccess',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, enable_concurrent_reads=None, is_enable_concurrent_reads=None, enable_casesensitive_namespace=False, is_enable_casesensitive_namespace=False, enable_symlink_creation=False, is_enable_symlink_creation=False, enable_simulteneous_access=False, is_enable_simulteneous_access=False, *args, **kwargs):  # noqa: E501
        """MultiProtocol - a model defined in Swagger
            \nMulti protocol object.
        """
        self.__enable_concurrent_reads = None
        self.__is_enable_concurrent_reads = None
        self.__enable_casesensitive_namespace = None
        self.__is_enable_casesensitive_namespace = None
        self.__enable_symlink_creation = None
        self.__is_enable_symlink_creation = None
        self.__enable_simulteneous_access = None
        self.__is_enable_simulteneous_access = None
        self.discriminator = None
        if enable_concurrent_reads is not None:
            self.__enable_concurrent_reads = enable_concurrent_reads
        if is_enable_concurrent_reads is not None:
            self.__is_enable_concurrent_reads = is_enable_concurrent_reads
        if enable_casesensitive_namespace is not None:
            self.__enable_casesensitive_namespace = enable_casesensitive_namespace
        if is_enable_casesensitive_namespace is not None:
            self.__is_enable_casesensitive_namespace = is_enable_casesensitive_namespace
        if enable_symlink_creation is not None:
            self.__enable_symlink_creation = enable_symlink_creation
        if is_enable_symlink_creation is not None:
            self.__is_enable_symlink_creation = is_enable_symlink_creation
        if enable_simulteneous_access is not None:
            self.__enable_simulteneous_access = enable_simulteneous_access
        if is_enable_simulteneous_access is not None:
            self.__is_enable_simulteneous_access = is_enable_simulteneous_access
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.MultiProtocol'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.MultiProtocol'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def enable_concurrent_reads(self):
        """`{ bool }`
            \nFlag to enable concurrent reads. This field will be deprecated.
        """ # noqa: E501
        return self.__enable_concurrent_reads

    @enable_concurrent_reads.setter
    def enable_concurrent_reads(self, enable_concurrent_reads):

        self.__enable_concurrent_reads = enable_concurrent_reads

    @property
    def is_enable_concurrent_reads(self):
        """`{ bool }`
            \nFlag to enable concurrent reads.
        """ # noqa: E501
        return self.__is_enable_concurrent_reads

    @is_enable_concurrent_reads.setter
    def is_enable_concurrent_reads(self, is_enable_concurrent_reads):

        self.__is_enable_concurrent_reads = is_enable_concurrent_reads

    @property
    def enable_casesensitive_namespace(self):
        """`{ bool }`
            \nFlag to enable case sensitive name space. This field will be deprecated.
        """ # noqa: E501
        return self.__enable_casesensitive_namespace

    @enable_casesensitive_namespace.setter
    def enable_casesensitive_namespace(self, enable_casesensitive_namespace):

        self.__enable_casesensitive_namespace = enable_casesensitive_namespace

    @property
    def is_enable_casesensitive_namespace(self):
        """`{ bool }`
            \nFlag to enable case sensitive name space.
        """ # noqa: E501
        return self.__is_enable_casesensitive_namespace

    @is_enable_casesensitive_namespace.setter
    def is_enable_casesensitive_namespace(self, is_enable_casesensitive_namespace):

        self.__is_enable_casesensitive_namespace = is_enable_casesensitive_namespace

    @property
    def enable_symlink_creation(self):
        """`{ bool }`
            \nFlag to enable symlink creation. This field will be deprecated.
        """ # noqa: E501
        return self.__enable_symlink_creation

    @enable_symlink_creation.setter
    def enable_symlink_creation(self, enable_symlink_creation):

        self.__enable_symlink_creation = enable_symlink_creation

    @property
    def is_enable_symlink_creation(self):
        """`{ bool }`
            \nFlag to enable symlink creation.
        """ # noqa: E501
        return self.__is_enable_symlink_creation

    @is_enable_symlink_creation.setter
    def is_enable_symlink_creation(self, is_enable_symlink_creation):

        self.__is_enable_symlink_creation = is_enable_symlink_creation

    @property
    def enable_simulteneous_access(self):
        """`{ bool }`
            \nFlag to enable simultaneous access. This field will be deprecated.
        """ # noqa: E501
        return self.__enable_simulteneous_access

    @enable_simulteneous_access.setter
    def enable_simulteneous_access(self, enable_simulteneous_access):

        self.__enable_simulteneous_access = enable_simulteneous_access

    @property
    def is_enable_simulteneous_access(self):
        """`{ bool }`
            \nFlag to enable simultaneous access.
        """ # noqa: E501
        return self.__is_enable_simulteneous_access

    @is_enable_simulteneous_access.setter
    def is_enable_simulteneous_access(self, is_enable_simulteneous_access):

        self.__is_enable_simulteneous_access = is_enable_simulteneous_access

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MultiProtocol, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MultiProtocol):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

