# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.AuthType import AuthType  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class NfsOptions(ExternalizableAbstractModel):
    """NfsOptions - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'hardlink_optimization': 'bool',
        'auth_type': 'files.v4.config.AuthType',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'hardlink_optimization': 'hardlinkOptimization',
        'auth_type': 'authType',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, hardlink_optimization=True, auth_type=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """NfsOptions - a model defined in Swagger
            \nNFS options details.
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__hardlink_optimization = None
        self.__auth_type = None
        self.discriminator = None
        if hardlink_optimization is not None:
            self.__hardlink_optimization = hardlink_optimization
        if auth_type is not None:
            self.__auth_type = auth_type

    def _initialize_object_type(self):
        return 'files.v4.config.NfsOptions'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.NfsOptions'


    @property
    def hardlink_optimization(self):
        """`{ bool }`
            \nHard link optimization for NFS.
        """ # noqa: E501
        return self.__hardlink_optimization

    @hardlink_optimization.setter
    def hardlink_optimization(self, hardlink_optimization):

        self.__hardlink_optimization = hardlink_optimization

    @property
    def auth_type(self):
        """`{ files.v4.config.AuthType }`
            
        """ # noqa: E501
        return self.__auth_type

    @auth_type.setter
    def auth_type(self, auth_type):

        self.__auth_type = auth_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NfsOptions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NfsOptions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

