# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.AnonymousIdentifier import AnonymousIdentifier  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.ClientAccessType import ClientAccessType  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.FilesAuthenticationType import FilesAuthenticationType  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.SquashType import SquashType  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class NfsProtocol(object):
    """NfsProtocol - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'authentication_type': 'files.v4.config.FilesAuthenticationType',
        'client_access_type': 'files.v4.config.ClientAccessType',
        'squash_type': 'files.v4.config.SquashType',
        'anonymous_identifier': 'files.v4.config.AnonymousIdentifier',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'authentication_type': 'authenticationType',
        'client_access_type': 'clientAccessType',
        'squash_type': 'squashType',
        'anonymous_identifier': 'anonymousIdentifier',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, authentication_type=None, client_access_type=None, squash_type=None, anonymous_identifier=None, *args, **kwargs):  # noqa: E501
        """NfsProtocol - a model defined in Swagger
            \nNFS protocol object.
        """
        self.__authentication_type = None
        self.__client_access_type = None
        self.__squash_type = None
        self.__anonymous_identifier = None
        self.discriminator = None
        if authentication_type is not None:
            self.__authentication_type = authentication_type
        if client_access_type is not None:
            self.__client_access_type = client_access_type
        if squash_type is not None:
            self.__squash_type = squash_type
        if anonymous_identifier is not None:
            self.__anonymous_identifier = anonymous_identifier
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.NfsProtocol'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.NfsProtocol'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def authentication_type(self):
        """`{ files.v4.config.FilesAuthenticationType }`
            
        """ # noqa: E501
        return self.__authentication_type

    @authentication_type.setter
    def authentication_type(self, authentication_type):

        self.__authentication_type = authentication_type

    @property
    def client_access_type(self):
        """`{ files.v4.config.ClientAccessType }`
            
        """ # noqa: E501
        return self.__client_access_type

    @client_access_type.setter
    def client_access_type(self, client_access_type):

        self.__client_access_type = client_access_type

    @property
    def squash_type(self):
        """`{ files.v4.config.SquashType }`
            
        """ # noqa: E501
        return self.__squash_type

    @squash_type.setter
    def squash_type(self, squash_type):

        self.__squash_type = squash_type

    @property
    def anonymous_identifier(self):
        """`{ files.v4.config.AnonymousIdentifier }`
            
        """ # noqa: E501
        return self.__anonymous_identifier

    @anonymous_identifier.setter
    def anonymous_identifier(self, anonymous_identifier):

        self.__anonymous_identifier = anonymous_identifier

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NfsProtocol, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NfsProtocol):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

