# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class OneScheduleSpec(object):
    """OneScheduleSpec - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'start_time_hours': 'int',
        'start_time_minutes': 'int',
        'duration_minutes': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'start_time_hours': 'startTimeHours',
        'start_time_minutes': 'startTimeMinutes',
        'duration_minutes': 'durationMinutes',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, start_time_hours=None, start_time_minutes=None, duration_minutes=None, *args, **kwargs):  # noqa: E501
        """OneScheduleSpec - a model defined in Swagger
            \nSchedule for each day of week.
        """
        self.__start_time_hours = None
        self.__start_time_minutes = None
        self.__duration_minutes = None
        self.discriminator = None
        self.__start_time_hours = start_time_hours
        self.__start_time_minutes = start_time_minutes
        self.__duration_minutes = duration_minutes
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.OneScheduleSpec'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.OneScheduleSpec'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def start_time_hours(self):
        """`{ int }`
            \nStart time hour of the schedule
        """ # noqa: E501
        return self.__start_time_hours

    @start_time_hours.setter
    def start_time_hours(self, start_time_hours):
        if start_time_hours is None:
            raise ValueError("Invalid value for `start_time_hours`, must not be `None`")  # noqa: E501
        if start_time_hours is not None and start_time_hours > 24:  # noqa: E501
            raise ValueError("Invalid value for `start_time_hours`, must be a value less than or equal to `24`")  # noqa: E501
        if start_time_hours is not None and start_time_hours < 0:  # noqa: E501
            raise ValueError("Invalid value for `start_time_hours`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__start_time_hours = start_time_hours

    @property
    def start_time_minutes(self):
        """`{ int }`
            \nStart time minute of the schedule
        """ # noqa: E501
        return self.__start_time_minutes

    @start_time_minutes.setter
    def start_time_minutes(self, start_time_minutes):
        if start_time_minutes is None:
            raise ValueError("Invalid value for `start_time_minutes`, must not be `None`")  # noqa: E501
        if start_time_minutes is not None and start_time_minutes > 59:  # noqa: E501
            raise ValueError("Invalid value for `start_time_minutes`, must be a value less than or equal to `59`")  # noqa: E501
        if start_time_minutes is not None and start_time_minutes < 0:  # noqa: E501
            raise ValueError("Invalid value for `start_time_minutes`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__start_time_minutes = start_time_minutes

    @property
    def duration_minutes(self):
        """`{ int }`
            \nThe time difference between the start and the end time of schedule in minutes 
        """ # noqa: E501
        return self.__duration_minutes

    @duration_minutes.setter
    def duration_minutes(self, duration_minutes):
        if duration_minutes is None:
            raise ValueError("Invalid value for `duration_minutes`, must not be `None`")  # noqa: E501
        if duration_minutes is not None and duration_minutes > 1440:  # noqa: E501
            raise ValueError("Invalid value for `duration_minutes`, must be a value less than or equal to `1440`")  # noqa: E501
        if duration_minutes is not None and duration_minutes < 0:  # noqa: E501
            raise ValueError("Invalid value for `duration_minutes`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__duration_minutes = duration_minutes

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OneScheduleSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OneScheduleSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

