# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class ScaleOutSpec(object):
    """ScaleOutSpec - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'number_of_expected_vms': 'int',
        'internal_ip_adresses': 'list[common.v1.config.IPAddress]',
        'external_ip_addresses': 'list[common.v1.config.IPAddress]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'number_of_expected_vms': 'numberOfExpectedVms',
        'internal_ip_adresses': 'internalIpAdresses',
        'external_ip_addresses': 'externalIpAddresses',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, number_of_expected_vms=None, internal_ip_adresses=None, external_ip_addresses=None, *args, **kwargs):  # noqa: E501
        """ScaleOutSpec - a model defined in Swagger
            \nScale out of a file server.
        """
        self.__number_of_expected_vms = None
        self.__internal_ip_adresses = None
        self.__external_ip_addresses = None
        self.discriminator = None
        if number_of_expected_vms is not None:
            self.__number_of_expected_vms = number_of_expected_vms
        if internal_ip_adresses is not None:
            self.__internal_ip_adresses = internal_ip_adresses
        if external_ip_addresses is not None:
            self.__external_ip_addresses = external_ip_addresses
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.ScaleOutSpec'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.ScaleOutSpec'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def number_of_expected_vms(self):
        """`{ int }`
            \nThe recommended number of file server VMs.
        """ # noqa: E501
        return self.__number_of_expected_vms

    @number_of_expected_vms.setter
    def number_of_expected_vms(self, number_of_expected_vms):
        if number_of_expected_vms is not None and number_of_expected_vms < 0:  # noqa: E501
            raise ValueError("Invalid value for `number_of_expected_vms`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__number_of_expected_vms = number_of_expected_vms

    @property
    def internal_ip_adresses(self):
        """`{ list[common.v1.config.IPAddress] }`
            \nList of internal network IP addresses.
        """ # noqa: E501
        return self.__internal_ip_adresses

    @internal_ip_adresses.setter
    def internal_ip_adresses(self, internal_ip_adresses):

        self.__internal_ip_adresses = internal_ip_adresses

    @property
    def external_ip_addresses(self):
        """`{ list[common.v1.config.IPAddress] }`
            \nList of external network IP addresses.
        """ # noqa: E501
        return self.__external_ip_addresses

    @external_ip_addresses.setter
    def external_ip_addresses(self, external_ip_addresses):

        self.__external_ip_addresses = external_ip_addresses

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleOutSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleOutSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

