# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.ScheduleType import ScheduleType  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class Schedule(object):
    """Schedule - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'multiple': 'int',
        'schedule_type': 'files.v4.config.ScheduleType',
        'start_time': 'str',
        'start_time_i_s_o8601': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'multiple': 'multiple',
        'schedule_type': 'scheduleType',
        'start_time': 'startTime',
        'start_time_i_s_o8601': 'startTimeISO8601',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, multiple=None, schedule_type=None, start_time=None, start_time_i_s_o8601=None, *args, **kwargs):  # noqa: E501
        """Schedule - a model defined in Swagger
            \nThis contains the schedule for all the policy. This has the start time and frequency information of the policy.
        """
        self.__multiple = None
        self.__schedule_type = None
        self.__start_time = None
        self.__start_time_i_s_o8601 = None
        self.discriminator = None
        self.__multiple = multiple
        self.__schedule_type = schedule_type
        if start_time is not None:
            self.__start_time = start_time
        if start_time_i_s_o8601 is not None:
            self.__start_time_i_s_o8601 = start_time_i_s_o8601
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.config.Schedule'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.Schedule'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def multiple(self):
        """`{ int }`
            \nRPO (Integer values are multiplied by schedule type to get the next scheduled repetition time).
        """ # noqa: E501
        return self.__multiple

    @multiple.setter
    def multiple(self, multiple):
        if multiple is None:
            raise ValueError("Invalid value for `multiple`, must not be `None`")  # noqa: E501

        self.__multiple = multiple

    @property
    def schedule_type(self):
        """`{ files.v4.config.ScheduleType }`
            
        """ # noqa: E501
        return self.__schedule_type

    @schedule_type.setter
    def schedule_type(self, schedule_type):
        if schedule_type is None:
            raise ValueError("Invalid value for `schedule_type`, must not be `None`")  # noqa: E501

        self.__schedule_type = schedule_type

    @property
    def start_time(self):
        """`{ str }`
            \nTime of the day, the policy will be started. If the value not set, the policy will be applicable immediately.
        """ # noqa: E501
        return self.__start_time

    @start_time.setter
    def start_time(self, start_time):
        if start_time is not None and not re.search('^\\d{4}-\\d\\d-\\d\\dT\\d\\d:\\d\\d:\\d\\d(\\.\\d+)?(([+-]\\d\\d:\\d\\d)|Z)?$', start_time):  # noqa: E501
            raise ValueError(r"Invalid value for `start_time`, must be a follow pattern or equal to `/^\\d{4}-\\d\\d-\\d\\dT\\d\\d:\\d\\d:\\d\\d(\\.\\d+)?(([+-]\\d\\d:\\d\\d)|Z)?$/`")  # noqa: E501

        self.__start_time = start_time

    @property
    def start_time_i_s_o8601(self):
        """`{ str }`
            \nTime of the day, the policy will be started. If the value not set, the policy will be applicable immediately.
        """ # noqa: E501
        return self.__start_time_i_s_o8601

    @start_time_i_s_o8601.setter
    def start_time_i_s_o8601(self, start_time_i_s_o8601):
        if start_time_i_s_o8601 is not None and not re.search('^\\d{4}-\\d\\d-\\d\\dT\\d\\d:\\d\\d:\\d\\d(\\.\\d+)?(([+-]\\d\\d:\\d\\d)|Z)?$', start_time_i_s_o8601):  # noqa: E501
            raise ValueError(r"Invalid value for `start_time_i_s_o8601`, must be a follow pattern or equal to `/^\\d{4}-\\d\\d-\\d\\dT\\d\\d:\\d\\d:\\d\\d(\\.\\d+)?(([+-]\\d\\d:\\d\\d)|Z)?$/`")  # noqa: E501

        self.__start_time_i_s_o8601 = start_time_i_s_o8601

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Schedule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Schedule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

