# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.config.PerDayScheduleSpec import PerDayScheduleSpec  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class TieringConfig(ExternalizableAbstractModel):
    """TieringConfig - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'capacity_threshold': 'int',
        'schedule': 'list[files.v4.config.PerDayScheduleSpec]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'capacity_threshold': 'capacityThreshold',
        'schedule': 'schedule',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, capacity_threshold=None, schedule=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        """TieringConfig - a model defined in Swagger
            \nRequest body specification for tiering configuration APIs.
        """
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__capacity_threshold = None
        self.__schedule = None
        self.discriminator = None
        if capacity_threshold is not None:
            self.__capacity_threshold = capacity_threshold
        if schedule is not None:
            self.__schedule = schedule

    def _initialize_object_type(self):
        return 'files.v4.config.TieringConfig'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.config.TieringConfig'


    @property
    def capacity_threshold(self):
        """`{ int }`
            \nCapacity threshold for tiering.
        """ # noqa: E501
        return self.__capacity_threshold

    @capacity_threshold.setter
    def capacity_threshold(self, capacity_threshold):
        if capacity_threshold is not None and capacity_threshold > 100:  # noqa: E501
            raise ValueError("Invalid value for `capacity_threshold`, must be a value less than or equal to `100`")  # noqa: E501
        if capacity_threshold is not None and capacity_threshold < 0:  # noqa: E501
            raise ValueError("Invalid value for `capacity_threshold`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__capacity_threshold = capacity_threshold

    @property
    def schedule(self):
        """`{ list[files.v4.config.PerDayScheduleSpec] }`
            \nTiering schedule for on-prem tiering.
        """ # noqa: E501
        return self.__schedule

    @schedule.setter
    def schedule(self, schedule):

        self.__schedule = schedule

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TieringConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TieringConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

