# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.FileServer import FileServer  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class FileServerInfo(object):
    """FileServerInfo - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'is_genesis_status': 'bool',
        'is_ha_state': 'bool',
        'is_file_server_info': 'bool',
        'genesis_status': 'str',
        'is_in_ha_state': 'bool',
        'file_server': 'files.v4.config.FileServer',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_genesis_status': 'isGenesisStatus',
        'is_ha_state': 'isHaState',
        'is_file_server_info': 'isFileServerInfo',
        'genesis_status': 'genesisStatus',
        'is_in_ha_state': 'isInHaState',
        'file_server': 'fileServer',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_genesis_status=None, is_ha_state=None, is_file_server_info=None, genesis_status=None, is_in_ha_state=None, file_server=None, *args, **kwargs):  # noqa: E501
        """FileServerInfo - a model defined in Swagger
            \nA model that represents the file server information. 
        """
        self.__is_genesis_status = None
        self.__is_ha_state = None
        self.__is_file_server_info = None
        self.__genesis_status = None
        self.__is_in_ha_state = None
        self.__file_server = None
        self.discriminator = None
        if is_genesis_status is not None:
            self.__is_genesis_status = is_genesis_status
        if is_ha_state is not None:
            self.__is_ha_state = is_ha_state
        if is_file_server_info is not None:
            self.__is_file_server_info = is_file_server_info
        if genesis_status is not None:
            self.__genesis_status = genesis_status
        if is_in_ha_state is not None:
            self.__is_in_ha_state = is_in_ha_state
        if file_server is not None:
            self.__file_server = file_server
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.infra.FileServerInfo'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.infra.FileServerInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_genesis_status(self):
        """`{ bool }`
            \nGet request flag for genesis status. 
        """ # noqa: E501
        return self.__is_genesis_status

    @is_genesis_status.setter
    def is_genesis_status(self, is_genesis_status):

        self.__is_genesis_status = is_genesis_status

    @property
    def is_ha_state(self):
        """`{ bool }`
            \nGet request flag for HA state. 
        """ # noqa: E501
        return self.__is_ha_state

    @is_ha_state.setter
    def is_ha_state(self, is_ha_state):

        self.__is_ha_state = is_ha_state

    @property
    def is_file_server_info(self):
        """`{ bool }`
            \nGet request flag for file server specification. 
        """ # noqa: E501
        return self.__is_file_server_info

    @is_file_server_info.setter
    def is_file_server_info(self, is_file_server_info):

        self.__is_file_server_info = is_file_server_info

    @property
    def genesis_status(self):
        """`{ str }`
            \nGenesis status output from NVM. 
        """ # noqa: E501
        return self.__genesis_status

    @genesis_status.setter
    def genesis_status(self, genesis_status):

        self.__genesis_status = genesis_status

    @property
    def is_in_ha_state(self):
        """`{ bool }`
            \nFlag that represents the file server is in HA state. 
        """ # noqa: E501
        return self.__is_in_ha_state

    @is_in_ha_state.setter
    def is_in_ha_state(self, is_in_ha_state):

        self.__is_in_ha_state = is_in_ha_state

    @property
    def file_server(self):
        """`{ files.v4.config.FileServer }`
            
        """ # noqa: E501
        return self.__file_server

    @file_server.setter
    def file_server(self, file_server):

        self.__file_server = file_server

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FileServerInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileServerInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

