# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.infra.FilesInfraLockEndpoint import FilesInfraLockEndpoint  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.infra.FilesInfraLockScope import FilesInfraLockScope  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class FilesInfraLock(object):
    """FilesInfraLock - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'operation_name': 'str',
        'message': 'str',
        'endpoint': 'files.v4.infra.FilesInfraLockEndpoint',
        'scope': 'files.v4.infra.FilesInfraLockScope',
        'scope_id': 'str',
        'timestamp': 'int',
        'timeout_secs': 'int',
        'lock_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'operation_name': 'operationName',
        'message': 'message',
        'endpoint': 'endpoint',
        'scope': 'scope',
        'scope_id': 'scopeId',
        'timestamp': 'timestamp',
        'timeout_secs': 'timeoutSecs',
        'lock_id': 'lockId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, operation_name=None, message=None, endpoint=None, scope=None, scope_id=None, timestamp=None, timeout_secs=None, lock_id=None, *args, **kwargs):  # noqa: E501
        """FilesInfraLock - a model defined in Swagger
            \nA model that represents the files infrastructure lock specification. 
        """
        self.__operation_name = None
        self.__message = None
        self.__endpoint = None
        self.__scope = None
        self.__scope_id = None
        self.__timestamp = None
        self.__timeout_secs = None
        self.__lock_id = None
        self.discriminator = None
        if operation_name is not None:
            self.__operation_name = operation_name
        if message is not None:
            self.__message = message
        if endpoint is not None:
            self.__endpoint = endpoint
        if scope is not None:
            self.__scope = scope
        if scope_id is not None:
            self.__scope_id = scope_id
        if timestamp is not None:
            self.__timestamp = timestamp
        if timeout_secs is not None:
            self.__timeout_secs = timeout_secs
        if lock_id is not None:
            self.__lock_id = lock_id
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.infra.FilesInfraLock'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.infra.FilesInfraLock'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def operation_name(self):
        """`{ str }`
            \nOperation name that acquired the lock. 
        """ # noqa: E501
        return self.__operation_name

    @operation_name.setter
    def operation_name(self, operation_name):

        self.__operation_name = operation_name

    @property
    def message(self):
        """`{ str }`
            \nOperation description message. 
        """ # noqa: E501
        return self.__message

    @message.setter
    def message(self, message):

        self.__message = message

    @property
    def endpoint(self):
        """`{ files.v4.infra.FilesInfraLockEndpoint }`
            
        """ # noqa: E501
        return self.__endpoint

    @endpoint.setter
    def endpoint(self, endpoint):

        self.__endpoint = endpoint

    @property
    def scope(self):
        """`{ files.v4.infra.FilesInfraLockScope }`
            
        """ # noqa: E501
        return self.__scope

    @scope.setter
    def scope(self, scope):

        self.__scope = scope

    @property
    def scope_id(self):
        """`{ str }`
            \nIdentification for the scope. For example: taskId 
        """ # noqa: E501
        return self.__scope_id

    @scope_id.setter
    def scope_id(self, scope_id):

        self.__scope_id = scope_id

    @property
    def timestamp(self):
        """`{ int }`
            \nTime when lock was last acquired. 
        """ # noqa: E501
        return self.__timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        if timestamp is not None and timestamp < 0:  # noqa: E501
            raise ValueError("Invalid value for `timestamp`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__timestamp = timestamp

    @property
    def timeout_secs(self):
        """`{ int }`
            \nExpiry time for the lock. 
        """ # noqa: E501
        return self.__timeout_secs

    @timeout_secs.setter
    def timeout_secs(self, timeout_secs):
        if timeout_secs is not None and timeout_secs < 0:  # noqa: E501
            raise ValueError("Invalid value for `timeout_secs`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__timeout_secs = timeout_secs

    @property
    def lock_id(self):
        """`{ str }`
            \nUnique Id for the lock. 
        """ # noqa: E501
        return self.__lock_id

    @lock_id.setter
    def lock_id(self, lock_id):

        self.__lock_id = lock_id

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FilesInfraLock, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FilesInfraLock):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

