# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.config.VM import VM  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class NvmAddInfo(object):
    """NvmAddInfo - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'dns_domain_name': 'str',
        'size_in_gb': 'float',
        'cvm_ips': 'list[str]',
        'dns_ipv4_address_list': 'list[str]',
        'ntp_ipv4_address_list': 'list[str]',
        'nvm_add_list': 'list[files.v4.config.VM]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'dns_domain_name': 'dnsDomainName',
        'size_in_gb': 'sizeInGb',
        'cvm_ips': 'cvmIps',
        'dns_ipv4_address_list': 'dnsIpv4AddressList',
        'ntp_ipv4_address_list': 'ntpIpv4AddressList',
        'nvm_add_list': 'nvmAddList',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, dns_domain_name=None, size_in_gb=None, cvm_ips=None, dns_ipv4_address_list=None, ntp_ipv4_address_list=None, nvm_add_list=None, *args, **kwargs):  # noqa: E501
        """NvmAddInfo - a model defined in Swagger
            \nA model that represents the NVM add information. 
        """
        self.__dns_domain_name = None
        self.__size_in_gb = None
        self.__cvm_ips = None
        self.__dns_ipv4_address_list = None
        self.__ntp_ipv4_address_list = None
        self.__nvm_add_list = None
        self.discriminator = None
        if dns_domain_name is not None:
            self.__dns_domain_name = dns_domain_name
        if size_in_gb is not None:
            self.__size_in_gb = size_in_gb
        if cvm_ips is not None:
            self.__cvm_ips = cvm_ips
        if dns_ipv4_address_list is not None:
            self.__dns_ipv4_address_list = dns_ipv4_address_list
        if ntp_ipv4_address_list is not None:
            self.__ntp_ipv4_address_list = ntp_ipv4_address_list
        if nvm_add_list is not None:
            self.__nvm_add_list = nvm_add_list
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.infra.NvmAddInfo'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.infra.NvmAddInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def dns_domain_name(self):
        """`{ str }`
            \nDNS domain name for the file server. 
        """ # noqa: E501
        return self.__dns_domain_name

    @dns_domain_name.setter
    def dns_domain_name(self, dns_domain_name):

        self.__dns_domain_name = dns_domain_name

    @property
    def size_in_gb(self):
        """`{ float }`
            \nFile server size in Gb. 
        """ # noqa: E501
        return self.__size_in_gb

    @size_in_gb.setter
    def size_in_gb(self, size_in_gb):

        self.__size_in_gb = size_in_gb

    @property
    def cvm_ips(self):
        """`{ list[str] }`
            \nCVM IPV4 address list of the cluster. 
        """ # noqa: E501
        return self.__cvm_ips

    @cvm_ips.setter
    def cvm_ips(self, cvm_ips):

        self.__cvm_ips = cvm_ips

    @property
    def dns_ipv4_address_list(self):
        """`{ list[str] }`
            \nDNS IPV4 address list for file server. 
        """ # noqa: E501
        return self.__dns_ipv4_address_list

    @dns_ipv4_address_list.setter
    def dns_ipv4_address_list(self, dns_ipv4_address_list):

        self.__dns_ipv4_address_list = dns_ipv4_address_list

    @property
    def ntp_ipv4_address_list(self):
        """`{ list[str] }`
            \nNTP IPV4 address list for file server. 
        """ # noqa: E501
        return self.__ntp_ipv4_address_list

    @ntp_ipv4_address_list.setter
    def ntp_ipv4_address_list(self, ntp_ipv4_address_list):

        self.__ntp_ipv4_address_list = ntp_ipv4_address_list

    @property
    def nvm_add_list(self):
        """`{ list[files.v4.config.VM] }`
            \nList of VMs to be added. 
        """ # noqa: E501
        return self.__nvm_add_list

    @nvm_add_list.setter
    def nvm_add_list(self, nvm_add_list):

        self.__nvm_add_list = nvm_add_list

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NvmAddInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NvmAddInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

