# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class PlatformFilesVirtualNetworkInfo(object):
    """PlatformFilesVirtualNetworkInfo - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'ext_id': 'str',
        'name': 'str',
        'subnet_mask': 'common.v1.config.IPAddress',
        'default_gateway': 'common.v1.config.IPAddress',
        'available_i_pv4_address_list': 'list[str]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ext_id': 'extId',
        'name': 'name',
        'subnet_mask': 'subnetMask',
        'default_gateway': 'defaultGateway',
        'available_i_pv4_address_list': 'availableIPv4AddressList',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ext_id=None, name=None, subnet_mask=None, default_gateway=None, available_i_pv4_address_list=None, *args, **kwargs):  # noqa: E501
        """PlatformFilesVirtualNetworkInfo - a model defined in Swagger
            \nA model that represents the platform files virtual network information along with available IPV4 addresses. 
        """
        self.__ext_id = None
        self.__name = None
        self.__subnet_mask = None
        self.__default_gateway = None
        self.__available_i_pv4_address_list = None
        self.discriminator = None
        if ext_id is not None:
            self.__ext_id = ext_id
        if name is not None:
            self.__name = name
        if subnet_mask is not None:
            self.__subnet_mask = subnet_mask
        if default_gateway is not None:
            self.__default_gateway = default_gateway
        if available_i_pv4_address_list is not None:
            self.__available_i_pv4_address_list = available_i_pv4_address_list
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.infra.PlatformFilesVirtualNetworkInfo'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.infra.PlatformFilesVirtualNetworkInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ext_id(self):
        """`{ str }`
            \nUUID of the the file server network.
        """ # noqa: E501
        return self.__ext_id

    @ext_id.setter
    def ext_id(self, ext_id):

        self.__ext_id = ext_id

    @property
    def name(self):
        """`{ str }`
            \nName of the network.
        """ # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):

        self.__name = name

    @property
    def subnet_mask(self):
        """`{ common.v1.config.IPAddress }`
            
        """ # noqa: E501
        return self.__subnet_mask

    @subnet_mask.setter
    def subnet_mask(self, subnet_mask):

        self.__subnet_mask = subnet_mask

    @property
    def default_gateway(self):
        """`{ common.v1.config.IPAddress }`
            
        """ # noqa: E501
        return self.__default_gateway

    @default_gateway.setter
    def default_gateway(self, default_gateway):

        self.__default_gateway = default_gateway

    @property
    def available_i_pv4_address_list(self):
        """`{ list[str] }`
            \nList of available IPV4 addresses to allocate from the virtual network address pool. 
        """ # noqa: E501
        return self.__available_i_pv4_address_list

    @available_i_pv4_address_list.setter
    def available_i_pv4_address_list(self, available_i_pv4_address_list):

        self.__available_i_pv4_address_list = available_i_pv4_address_list

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PlatformFilesVirtualNetworkInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlatformFilesVirtualNetworkInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

