# coding: utf-8


"""
IGNORE:
    Nutanix Files Versioned APIs

    Manage virtual file servers, create and configure shares for client access, protect them using DR and sync policies, provision storage space and administer security controls.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_files_py_client.Ntnx.files.v4.infra.HttpProxy import HttpProxy  # noqa: F401,E501
from ntnx_files_py_client.Ntnx.files.v4.infra.PiiScrubbingLevel import PiiScrubbingLevel  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class PulseConfig(object):
    """PulseConfig - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'pulse_enabled': 'bool',
        'pii_scrubbing_level': 'files.v4.infra.PiiScrubbingLevel',
        'http_proxy_list': 'list[files.v4.infra.HttpProxy]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'pulse_enabled': 'pulseEnabled',
        'pii_scrubbing_level': 'piiScrubbingLevel',
        'http_proxy_list': 'httpProxyList',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, pulse_enabled=None, pii_scrubbing_level=None, http_proxy_list=None, *args, **kwargs):  # noqa: E501
        """PulseConfig - a model defined in Swagger
            \nPulse configuration model. 
        """
        self.__pulse_enabled = None
        self.__pii_scrubbing_level = None
        self.__http_proxy_list = None
        self.discriminator = None
        if pulse_enabled is not None:
            self.__pulse_enabled = pulse_enabled
        if pii_scrubbing_level is not None:
            self.__pii_scrubbing_level = pii_scrubbing_level
        if http_proxy_list is not None:
            self.__http_proxy_list = http_proxy_list
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'files.v4.infra.PulseConfig'

    def _initialize_fq_object_type(self):
        return 'files.v4.r0.a2.infra.PulseConfig'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def pulse_enabled(self):
        """`{ bool }`
            \nEnable pulse on file server. 
        """ # noqa: E501
        return self.__pulse_enabled

    @pulse_enabled.setter
    def pulse_enabled(self, pulse_enabled):

        self.__pulse_enabled = pulse_enabled

    @property
    def pii_scrubbing_level(self):
        """`{ files.v4.infra.PiiScrubbingLevel }`
            
        """ # noqa: E501
        return self.__pii_scrubbing_level

    @pii_scrubbing_level.setter
    def pii_scrubbing_level(self, pii_scrubbing_level):

        self.__pii_scrubbing_level = pii_scrubbing_level

    @property
    def http_proxy_list(self):
        """`{ list[files.v4.infra.HttpProxy] }`
            \nList of http proxy servers for pulse data. 
        """ # noqa: E501
        return self.__http_proxy_list

    @http_proxy_list.setter
    def http_proxy_list(self, http_proxy_list):

        self.__http_proxy_list = http_proxy_list

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PulseConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PulseConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

